IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'ATUALIZA_ATIVO_EXP' AND
	              TYPE = 'P' 			           AND
      	        U.UID = O.UID                 AND
      	        U.NAME = USER)
DROP PROCEDURE ATUALIZA_ATIVO_EXP
GO

CREATE PROCEDURE ATUALIZA_ATIVO_EXP @P_CDFILIAL     VARCHAR(4),
                                    @P_NREXPEDICAO  VARCHAR(10),
                                    @P_CDOPERADOR   VARCHAR(12)
AS
   DECLARE @V_CTPARFACI         DOUBLE PRECISION;
   DECLARE @V_CTCAPA            DOUBLE PRECISION;
   DECLARE @V_NRSEQCAPAOPEBEM   VARCHAR(20);
   DECLARE @V_NRSEQITCAPAOPE    VARCHAR(20);
   DECLARE @V_NRSEQOPERABEM     VARCHAR(20);
   DECLARE @V_DTCAPAOPEBEM      DATETIME;
   DECLARE @V_CDCLIENTEANTE     VARCHAR(21);
   DECLARE @V_CDTIPOOPERBEM     VARCHAR(6);
   DECLARE @V_CDMOTIVOOPER      VARCHAR(6);

   DECLARE @V_CDEMPRESA         VARCHAR(2);
   DECLARE @V_CDBEMATIVO        VARCHAR(10);
   DECLARE @V_QTATUABEMATIVO    DOUBLE PRECISION;
   DECLARE @V_CDFILIALBEM       VARCHAR(4);
   DECLARE @V_CDCENTCUST        VARCHAR(4);
   DECLARE @V_CDSETOR           VARCHAR(4);
   DECLARE @V_CDGRUPOBEM        VARCHAR(6);
   DECLARE @V_VRJADEPBEMATIVO   DOUBLE PRECISION;
   DECLARE @V_CDTIPODEPREC      VARCHAR(6);
   DECLARE @V_VRINIDEPBEM       DOUBLE PRECISION;
   DECLARE @V_VRFALTADEPBEM     DOUBLE PRECISION;
   DECLARE @V_CDCLIENTE         VARCHAR(21);
   DECLARE @V_NRSEQORCAMENTO    DOUBLE PRECISION;
   DECLARE @V_CDFILIAL          VARCHAR(4);
   DECLARE @V_NRLANCTONF        VARCHAR(10);
   DECLARE @V_NRPEDIDO          VARCHAR(10);
   DECLARE @V_NRNOTAFISC        VARCHAR(20);
   DECLARE @V_CDSERIE           VARCHAR(5);
   DECLARE @V_VRTOTALITEMORCA   DOUBLE PRECISION;
   DECLARE @V_DTCAPAOPEBEMANTE  DATETIME;
   DECLARE @V_CDCONTADOR        VARCHAR(100);
   DECLARE @V_DSOBS             VARCHAR(200);
BEGIN
   SELECT @V_CTPARFACI = COUNT(*)
     FROM FCT_PARAMETROGERAL;

   IF @V_CTPARFACI > 0 BEGIN
      SET @V_CTCAPA = 0;
      DECLARE C_NOTA CURSOR FOR
         SELECT BE.CDEMPRESA, BE.CDBEMATIVO, BE.QTATUABEMATIVO,
                BE.CDFILIAL AS CDFILIALBEM, BE.CDCENTCUST, BE.CDSETOR,
                BE.CDGRUPOBEM, BE.VRJADEPBEMATIVO, BE.CDTIPODEPREC,
                BE.VRINIDEPBEM, BE.VRFALTADEPBEM, NF.CDCLIENTE,
                FI.NRSEQORCAMENTO, NF.CDFILIAL, NF.NRLANCTONF,
                IP.NRPEDIDO, NF.NRNOTAFISC, NF.CDSERIE,
                FI.VRTOTALITEMORCA
           FROM NOTAFISCAL NF, ITEMPRODUTO IT, ITEMPEDIDO IP,
                FCT_ITEMORCAMENTO FI, BEMATIVO BE
          WHERE NF.CDFILIAL = @P_CDFILIAL
            AND NF.NREXPEDICAO = @P_NREXPEDICAO
            AND NF.CDFILIAL = IT.CDFILIAL
            AND NF.NRLANCTONF = IT.NRLANCTONF
            AND IT.CDFILIALPED = IP.CDFILIAL
            AND IT.NRPEDIDO = IP.NRPEDIDO
            AND IT.NRITEMPED = IP.NRITEMPED
            AND IP.NRITEMORCAMENTO = FI.NRITEMORCAMENTOPAI
            AND FI.CDEMPRESA = BE.CDEMPRESA
            AND FI.CDBEMATIVO = BE.CDBEMATIVO
          ORDER BY FI.CDEMPRESA, FI.CDBEMATIVO
      OPEN C_NOTA;

      FETCH NEXT FROM C_NOTA INTO @V_CDEMPRESA, @V_CDBEMATIVO, @V_QTATUABEMATIVO,
                                  @V_CDFILIALBEM, @V_CDCENTCUST, @V_CDSETOR,
                                  @V_CDGRUPOBEM, @V_VRJADEPBEMATIVO, @V_CDTIPODEPREC,
                                  @V_VRINIDEPBEM, @V_VRFALTADEPBEM, @V_CDCLIENTE,
                                  @V_NRSEQORCAMENTO, @V_CDFILIAL, @V_NRLANCTONF,
                                  @V_NRPEDIDO, @V_NRNOTAFISC, @V_CDSERIE,
                                  @V_VRTOTALITEMORCA;
      WHILE (@@FETCH_STATUS = 0) BEGIN

         -- BUSCA A LTIMA ALTERAO DO BEM  --
         SET @V_DTCAPAOPEBEMANTE = NULL;
         SET @V_CDCLIENTEANTE = NULL;
         DECLARE C_BEM CURSOR FOR
            SELECT CA.DTCAPAOPEBEM, IT.CDCLIENTE
              FROM CAPAOPERABEM CA, ITCAPAOPERABEM IT
             WHERE IT.CDEMPRESA = @V_CDEMPRESA
               AND IT.CDBEMATIVO = @V_CDBEMATIVO
               AND CA.IDSIMULOPERABEM = 'R'
               AND CA.CDEMPRESA = IT.CDEMPRESA
               AND CA.IDSIMULOPERABEM = IT.IDSIMULOPERABEM
               AND CA.NRSEQCAPAOPEBEM = IT.NRSEQCAPAOPEBEM
             ORDER BY DTCAPAOPEBEM DESC
         OPEN C_BEM;
         FETCH NEXT FROM C_BEM INTO @V_DTCAPAOPEBEMANTE, @V_CDCLIENTEANTE;
         CLOSE C_BEM;
         DEALLOCATE C_BEM;

         -- BUSCA O TIPO E O MOTIVO DA OPERAO PARAMETRIZADO PARA EXPEDIO --
         SET @V_CDTIPOOPERBEM = NULL;
         SET @V_CDMOTIVOOPER  = NULL;
         SELECT @V_CDTIPOOPERBEM = CDTPOPERBEMEXP,
                @V_CDMOTIVOOPER = CDMTOPERBEMEXP
           FROM PARAMEMPRESA
          WHERE CDEMPRESA = @V_CDEMPRESA;

         IF @V_CTCAPA = 0 BEGIN  -- INSERE APENAS UMA CAPA --

            SET @V_CDCONTADOR = 'CAPAOPERABEM' + @V_CDEMPRESA + 'R';
            EXEC NOVO_CODIGO @V_CDCONTADOR, @P_SEQUENCIAL = @V_NRSEQCAPAOPEBEM OUTPUT;
            SET @V_NRSEQCAPAOPEBEM = SUBSTRING(@V_NRSEQCAPAOPEBEM, 11, 10);

            INSERT INTO CAPAOPERABEM
                (CDEMPRESA,         IDSIMULOPERABEM,    NRSEQCAPAOPEBEM,    DTCAPAOPEBEM,
                 CDTIPOOPERBEM,     CDMOTIVOOPER,       CDOPERESPOPERA,     IDIDENTCAPAOPER,
                 DTINCCAPAOPER,     CDOPEINCCAPA,       DTATUCAPAOPER,      CDOPEATUCAPA,
                 IDSITCAPAOPER,     DTCAPAOPEBEMANTE)
            VALUES
                (@V_CDEMPRESA,     'R',              @V_NRSEQCAPAOPEBEM,  GETDATE(),
                 @V_CDTIPOOPERBEM, @V_CDMOTIVOOPER,  @P_CDOPERADOR,       '03',
                 GETDATE(),        @P_CDOPERADOR,    GETDATE(),           @P_CDOPERADOR,
                 '2',              @V_DTCAPAOPEBEM);

            SET @V_CTCAPA = 1;
         END;

         SET @V_CDCONTADOR = 'OPERACAOBEM' + @V_CDEMPRESA + @V_CDBEMATIVO + 'R';
         EXEC NOVO_CODIGO @V_CDCONTADOR, @P_SEQUENCIAL = @V_NRSEQOPERABEM OUTPUT;
         SET @V_NRSEQOPERABEM = SUBSTRING(@V_NRSEQOPERABEM, 11, 10);

         INSERT INTO OPERACAOBEM
            (CDEMPRESA,       CDBEMATIVO,      IDSIMULOPERACAO,   NRSEQOPERABEM,    DTOPERABEM,    CDTIPOOPERBEM,
             CDOPERESPOPERA,  QTOPEBEMNOVO,    VROPERABEM,        CDFILIAL,         CDCENTCUST,    CDSETOR,
             CDGRUPOBEM,      QTMESDEPOPENOVO, QTMESFALDEPOPEB,   QTMESJADEPOPEB,   VRTAXDEPOPENOVO,
             CDTIPODEPREC,    VRINIDEPROPEBEM, VRJADEPROPEBEM,    VRFALDEPROPEBEM,  DTINCOPERABEM,
             CDOPEINCOPERABE, DTATUOPERABEM,   CDOPEATUOPERABE ,  IDIDENTOPERABEM,  IDSITOPERABEM, CDCLIENTE,
             CDFILIALNF    ,  NRLANCTONF,      CDMOTIVOOPER,      CDSERIENFOPERA)
         VALUES
            (@V_CDEMPRESA,    @V_CDBEMATIVO,      'R',                @V_NRSEQOPERABEM,   GETDATE(),     @V_CDTIPOOPERBEM,
             @P_CDOPERADOR,   @V_QTATUABEMATIVO , @V_VRTOTALITEMORCA, @V_CDFILIALBEM,     @V_CDCENTCUST, @V_CDSETOR,
             @V_CDGRUPOBEM,   0,                  0,                  @V_VRJADEPBEMATIVO, 0,
             @V_CDTIPODEPREC, @V_VRINIDEPBEM,     @V_VRJADEPBEMATIVO, @V_VRFALTADEPBEM,   GETDATE(),
             @P_CDOPERADOR,   GETDATE(),          @P_CDOPERADOR,      '03',               '1',           @V_CDCLIENTE,
             @V_CDFILIAL,     @V_NRLANCTONF,      @V_CDMOTIVOOPER,    @V_CDSERIE);

         -- A ITCAPAOPERABEM   includa depois da OPERACAOBEM  para gravar o NRSEQOPERABEM --
         SET @V_CDCONTADOR = 'ITCAPAOPERABEM' + @V_CDEMPRESA + 'R' + @V_NRSEQCAPAOPEBEM;
         EXEC NOVO_CODIGO @V_CDCONTADOR, @P_SEQUENCIAL = @V_NRSEQITCAPAOPE;
         SET @V_NRSEQITCAPAOPE = SUBSTRING(@V_NRSEQITCAPAOPE, 11, 10);

         SET @V_DSOBS = 'EXPEDIO DO PEDIDO: ' + @V_NRPEDIDO + ' - ORAMENTO: ' + @V_NRSEQORCAMENTO;
         INSERT INTO ITCAPAOPERABEM
             (CDEMPRESA,       IDSIMULOPERABEM, NRSEQCAPAOPEBEM, NRSEQITCAPAOPE,
              CDBEMATIVO,      QTITCAPAOPEANTE, QTITCAPAOPENOVO, VRITCAPAOPERA,
              CDFILIALITCANTE, CDFILIALITCNOVO, CDCENTCUITCANTE, CDCENTCUITCNOVO,
              CDSETORITCANTE,  CDSETORITCNOVO,  QTMESDEPITCANTE, QTMESDEPITCNOVO,
              VRTAXDEPITCANTE, VRTAXDEPITCNOVO, DTINCITCAPAOPER, DTATUITCAPAOPER,
              CDOPEATUITCAPA,  CDOPEINCITCAPA,  CDOPERESPBEMANT, CDOPERESPBEMNOV,
              CDCLIENTE     ,  CDCLIENTEANTE  , NRNOTAFIITCAPA , DSOBSITCAPAOPER,
              CDFILIALNF    ,  NRLANCTONF,      NRSEQOPERABEM)
         VALUES
             (@V_CDEMPRESA,   'R',               @V_NRSEQCAPAOPEBEM,  @V_NRSEQITCAPAOPE,
              @V_CDBEMATIVO,  @V_QTATUABEMATIVO, @V_QTATUABEMATIVO,   @V_VRTOTALITEMORCA,
              NULL,           NULL,              NULL,                NULL,
              NULL,           NULL,              0,                   0,
              0,              0,                 GETDATE(),           GETDATE(),
              @P_CDOPERADOR,  @P_CDOPERADOR,     @P_CDOPERADOR,       @P_CDOPERADOR,
              @V_CDCLIENTE,   @V_CDCLIENTEANTE,  @V_NRNOTAFISC,       @V_DSOBS,
              @V_CDFILIAL,    @V_NRLANCTONF, @V_NRSEQOPERABEM);

         FETCH NEXT FROM C_NOTA INTO @V_CDEMPRESA, @V_CDBEMATIVO, @V_QTATUABEMATIVO,
                                     @V_CDFILIALBEM, @V_CDCENTCUST, @V_CDSETOR,
                                     @V_CDGRUPOBEM, @V_VRJADEPBEMATIVO, @V_CDTIPODEPREC,
                                     @V_VRINIDEPBEM, @V_VRFALTADEPBEM, @V_CDCLIENTE,
                                     @V_NRSEQORCAMENTO, @V_CDFILIAL, @V_NRLANCTONF,
                                     @V_NRPEDIDO, @V_NRNOTAFISC, @V_CDSERIE,
                                     @V_VRTOTALITEMORCA;
      END;
      CLOSE C_NOTA;
      DEALLOCATE C_NOTA;
   END;
END;
GO

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_ATIVO_EXP','5.25.000'); END;
GO

